unit LecteurCDprg;              //249
   // Remerciement pour l'unit de Peter Stotz que j'ai honteusement pomp
   //                           jpstotz@gmx.de
interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, Propos;

type
  TLecteurCdFprg = class(TForm)
    Panel1: TPanel;
    Label1: TLabel;
    CBF1: TCheckBox;
    CBO1: TCheckBox;
    Label2: TLabel;
    CBF2: TCheckBox;
    CBO2: TCheckBox;
    CBF3: TCheckBox;
    CBO3: TCheckBox;
    CBF4: TCheckBox;
    CBO4: TCheckBox;
    CBF5: TCheckBox;
    CBO5: TCheckBox;
    CBF6: TCheckBox;
    CBO6: TCheckBox;
    CBF7: TCheckBox;
    CBO7: TCheckBox;
    CBF8: TCheckBox;
    CBO8: TCheckBox;
    CBF9: TCheckBox;
    CBO9: TCheckBox;
    CBF10: TCheckBox;
    CBO10: TCheckBox;
    Label4: TLabel;
    Label3: TLabel;
    BtAction: TButton;
    BtArret: TButton;
    BtApropos: TButton;
    Propos1: TPropos;
    procedure FormCreate(Sender: TObject);
    procedure CBF1MouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure CBO1MouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure BtArretClick(Sender: TObject);
    procedure BtActionClick(Sender: TObject);
    procedure BtAproposClick(Sender: TObject);
  private
    { Dclarations prives }
  public
    { Dclarations publiques }
  end;

var
  LecteurCdFprg: TLecteurCdFprg;

implementation

{$R *.dfm}
USES
  MMSystem;

function OpenCD(Drive : Char) : Boolean;
Var
  Res : MciError;
  OpenParm: TMCI_Open_Parms;
  Flags : DWord;
  S : String;
  DeviceID : Word;
begin
  Result:=false;
  S:=Drive+':';
  Flags:=mci_Open_Type or mci_Open_Element;
  With OpenParm do begin
    dwCallback := 0;
    lpstrDeviceType := 'CDAudio';
    lpstrElementName := PChar(S);
  end;
  Res := mciSendCommand(0, mci_Open, Flags, Longint(@OpenParm));
  IF Res<>0 Then exit;
  DeviceID:=OpenParm.wDeviceID;
  try
    Res:=mciSendCommand(DeviceID, MCI_SET, MCI_SET_DOOR_OPEN, 0);
    IF Res=0 Then exit;
    Result:=True;
  finally
    mciSendCommand(DeviceID, mci_Close, Flags, Longint(@OpenParm));
  end;  
end;

function CloseCD(Drive : Char) : Boolean;
Var
  Res : MciError;
  OpenParm: TMCI_Open_Parms;
  Flags : DWord;
  S : String;
  DeviceID : Word;
begin
  Result:=false;
  S:=Drive+':';
  Flags:=mci_Open_Type or mci_Open_Element;
  With OpenParm do begin
    dwCallback := 0;
    lpstrDeviceType := 'CDAudio';
    lpstrElementName := PChar(S);
  end;
  Res := mciSendCommand(0, mci_Open, Flags, Longint(@OpenParm));
  IF Res<>0 Then exit;
  DeviceID:=OpenParm.wDeviceID;
  try
    Res:=mciSendCommand(DeviceID, MCI_SET, MCI_SET_DOOR_CLOSED, 0);
    IF Res=0 Then exit;
    Result:=True;
  finally
    mciSendCommand(DeviceID, mci_Close, Flags, Longint(@OpenParm));
  end;  
end;

procedure TLecteurCdFprg.FormCreate(Sender: TObject);
VAR
  c_Lcd : Char;
  i_Lcd : Integer;
begin
  i_Lcd := 1;
  For c_Lcd := 'A' TO 'Z' DO
  BEGIN
    CASE GetDriveType(PChar(c_Lcd+':\')) OF
      DRIVE_REMOVABLE:BEGIN
        WITH TCheckBox(FindComponent('CBF' + IntToStr(i_Lcd))) DO
        BEGIN
          Enabled := FALSE;Visible := TRUE;
        END;
        WITH TCheckBox(FindComponent('CBO' + IntToStr(i_Lcd))) DO
        BEGIN
          Caption:='Disquette : '+c_Lcd+':\';Enabled := FALSE;Visible := TRUE;
        END;
        INC(i_Lcd);
      END;
      DRIVE_REMOTE:BEGIN
        WITH TCheckBox(FindComponent('CBF' + IntToStr(i_Lcd))) DO
        BEGIN
          Enabled := FALSE;Visible := TRUE;
        END;
        WITH TCheckBox(FindComponent('CBO' + IntToStr(i_Lcd))) DO
        BEGIN
          Caption:='Rseau :    '+c_Lcd+':\';Enabled := FALSE;Visible := TRUE;
        END;
        INC(i_Lcd);
      END;
      DRIVE_RAMDISK:BEGIN
        WITH TCheckBox(FindComponent('CBF' + IntToStr(i_Lcd))) DO
        BEGIN
          Enabled := FALSE;Visible := TRUE;
        END;
        WITH TCheckBox(FindComponent('CBO' + IntToStr(i_Lcd))) DO
        BEGIN
          Caption:='R.A.M. :    '+c_Lcd+':\';Enabled := FALSE;Visible := TRUE;
        END;
        INC(i_Lcd);
      END;
      DRIVE_CDROM:BEGIN
        WITH TCheckBox(FindComponent('CBF' + IntToStr(i_Lcd))) DO
        BEGIN
          Enabled := TRUE;Visible := TRUE;
        END;
        WITH TCheckBox(FindComponent('CBO' + IntToStr(i_Lcd))) DO
        BEGIN
          Caption:='C. D. :     '+c_Lcd+':\';Enabled := TRUE;Visible := TRUE;
        END;
        INC(i_Lcd);
      END;
      DRIVE_fixed:BEGIN
        WITH TCheckBox(FindComponent('CBF' + IntToStr(i_Lcd))) DO
        BEGIN
          Enabled := FALSE;Visible := TRUE;
        END;
        WITH TCheckBox(FindComponent('CBO' + IntToStr(i_Lcd))) DO
        BEGIN
          Caption:='disque :    '+c_Lcd+':\';Enabled := FALSE;Visible := TRUE;
        END;
        INC(i_Lcd);
      END;
    END;
  END;
end;

procedure TLecteurCdFprg.CBF1MouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
VAR
  i_Cbf : Integer;
begin
  FOR i_Cbf:=1 TO 10 DO
    IF (Sender= TCheckBox(FindComponent('CBF' + IntToStr(i_Cbf))))
        AND (TCheckBox(FindComponent('CBF' + IntToStr(i_Cbf))).
             State= cbChecked)
    THEN TCheckBox(FindComponent('CBO' + IntToStr(i_Cbf))).State := cbUnchecked;
end;

procedure TLecteurCdFprg.CBO1MouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
VAR
  i_Cbo : Integer;
begin
  FOR i_Cbo:=1 TO 10 DO
    IF (Sender=TCheckBox(FindComponent('CBO'+IntToStr(i_Cbo))))
        AND (TCheckBox(FindComponent('CBO' + IntToStr(i_Cbo))).
             State=cbChecked)
    THEN TCheckBox(FindComponent('CBF' + IntToStr(i_Cbo))).State := cbUnchecked;
end;

procedure TLecteurCdFprg.BtArretClick(Sender: TObject);
begin
  LecteurCDFPrg.Close;
end;

procedure TLecteurCdFprg.BtActionClick(Sender: TObject);
VAR
  i_Act : Integer;
  c_Act : String;
begin
  FOR i_Act:=1 TO 10 DO
  BEGIN
    c_Act := Copy(TCheckBox(FindComponent('CBO' + IntToStr(i_Act))).Caption,
                  pos('\',
                      TCheckBox(FindComponent('CBO' + IntToStr(i_Act))).
                                                                  Caption)-2,
                  1);
    IF (TCheckBox(FindComponent('CBO' + IntToStr(i_Act))).
        State=cbChecked)
    THEN OpenCd(c_Act[1]);
    IF (TCheckBox(FindComponent('CBF' + IntToStr(i_Act))).
        State=cbChecked)
    THEN CloseCd(c_Act[1]);
  END;
end;

procedure TLecteurCdFprg.BtAproposClick(Sender: TObject);
begin
  Propos1.PCaption := 'A propos de l''utilitaire pour tiroir CD';
  Propos1.PVersion := ('1.03');
  Propos1.Lignes.Add('Version 1.03 : 2003');
  Propos1.Lignes.Add('  Mise en circulation de l''utilitaire');
  Propos1.Lignes.Add('');
  Propos1.Lignes.Add('  ');
  propos1.Execute;
end;

end.
